"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.registerType = registerType;

var _core = require("@babel/core");

var _macroAssertions = require("./macro-assertions");

var _astToTypeIR = require("./type-ir/astToTypeIR");

// TODO: Handle circular types (Well... don't handle them)
function registerType(typeName, stmts, namedTypes) {
  const node = (0, _macroAssertions.getTypeDeclarationInBlock)(typeName, stmts);
  if (node === null) return;
  const externalTypes = new Set();
  let typeIR;

  if (_core.types.isTSTypeAliasDeclaration(node)) {
    typeIR = (0, _astToTypeIR.getTypeAliasIR)(node, externalTypes);
  } else {
    typeIR = (0, _astToTypeIR.getInterfaceIR)(node, externalTypes);
  }

  namedTypes.set(typeName, typeIR);

  for (const externalType of externalTypes) {
    if (!namedTypes.has(externalType)) {
      registerType(externalType, stmts, namedTypes);
    }
  }
}