"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.hasAtLeast1Element = hasAtLeast1Element;
exports.hasAtLeast2Elements = hasAtLeast2Elements;
exports.safeGet = safeGet;

var _macroAssertions = require("../macro-assertions");

function hasAtLeast1Element(array) {
  return array.length >= 1;
}

function hasAtLeast2Elements(array) {
  return array.length >= 2;
}

function safeGet(key, map, mapName) {
  const val = map.get(key);

  if (val === undefined) {
    (0, _macroAssertions.throwUnexpectedError)(`expected ${key} to be in map${mapName !== undefined ? mapName : ""}`);
  }

  return val;
}